﻿let saveContent = function ($textarea) {
    $textarea = $textarea || $('textarea');

    var content = $textarea.val();

    $.ajax('/api/save', {
        data: content,
        contentType: 'text/plain',
        type: 'POST'
    }).done(function (data) {

        // show 'saved' indicator
        $('#saved-indicator').addClass('show').delay(800).queue(function (next) {
            $(this).removeClass('show');
            next();
        });

    }).fail(function () {
        alert('Could not connect to server. Check your internet connection and try again.');
    });
};

$(function () {

    var timer = null;
    $('textarea').keyup(function () {
        clearTimeout(timer);
        timer = setTimeout(function () {
            saveContent();
        }, 500);
    });

    // 20 second interval
    setInterval(saveContent, 60000);

    //onbeforeunload = saveContent();

    // support tab key in textarea
    $('textarea').keydown(function (e) {
        if (e.keyCode === 9) { // tab was pressed
            // get caret position/selection
            var start = this.selectionStart;
            end = this.selectionEnd;

            var $this = $(this);

            // set textarea value to: text before caret + tab + text after caret
            $this.val($this.val().substring(0, start)
                + '\t'
                + $this.val().substring(end));

            // put caret at right position again
            this.selectionStart = this.selectionEnd = start + 1;

            // prevent the focus lose
            return false;
        }
    });

});